Name "MPCscan"
OutFile "MPCscan.exe"

!packhdr "MPCscan.dat" "upx.exe --best MPCscan.dat"
SetCompress          auto
SetDatablockOptimize on
CRCCheck             on
AutoCloseWindow      false
ShowInstDetails      show
SetDateSave          on
XPStyle              on

; --------------------------------------

Function CheckOS
ReadRegStr "$0" HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
StrCmp $0 "" iam_win9x iam_winnt

iam_win9x:
  ;win9x stuff here
  File "..\Release\MPCscan.exe"
StrCmp $0 "" iam_end

iam_winnt:
  ;winnt stuff here
  File "..\Release_U\MPCscan.exe"
iam_end:
FunctionEnd

; --------------------------------------

InstallDir "$PROGRAMFILES\Musepack"
DirShow show
DirText "Select the installation directory:"

ComponentText "Install options"

InstType "Normal"

Section ""
  DeleteRegKey HKCR "Directory\shell\MPCscan.Scan"
  Delete "$DESKTOP\MPCscan.lnk"
  SetOutPath "$INSTDIR"
SectionEnd

Section "MPCscan"
  SectionIn RO
  Call CheckOS
  AddSize 21
SectionEnd

Section "Directory context menu"
  SectionIn 1
  WriteRegStr HKCR "Directory\shell\MPCscan.Scan" "" "&MPCscan"
  WriteRegStr HKCR "Directory\shell\MPCscan.Scan\command" "" '"$INSTDIR\MPCscan.exe" "%1"'
SectionEnd

Section "Place icon on desktop"
  SectionIn 1
  CreateShortCut "$DESKTOP\MPCscan.lnk" "$INSTDIR\MPCscan.exe"
SectionEnd

Section "-post"
  WriteRegStr HKLM "Software\MPCscan" "InstallDir" "$INSTDIR"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MPCscan" "DisplayName" "MPCscan"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MPCscan" "UninstallString" '"$INSTDIR\uninst-MPCscan.exe"'
  WriteUninstaller "$INSTDIR\uninst-MPCscan.exe"
SectionEnd

UninstallText "This will uninstall MPCscan. Hit next to continue."
ShowUninstDetails Show

Section "Uninstall"
  Delete "$INSTDIR\uninst-MPCscan.exe"
  Delete "$INSTDIR\MPCscan.exe"
  
  DeleteRegKey HKCR "Directory\shell\MPCscan.Scan"
  DeleteRegKey HKLM "Software\MPCscan"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MPCscan"
  Delete "$DESKTOP\MPCscan.lnk"
  RMDir "$INSTDIR"
SectionEnd
